import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYItemRenderer;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.ui.RectangleInsets;

import java.util.Random;

public class ChartsPanel extends JPanel{
	JFreeChart chart[];
	XYSeriesCollection data[] ;
	double filedata[];
	int nlines;
	String username;

	public ChartsPanel(String user){
		username = user;
		chart = new JFreeChart[3];
		data = new XYSeriesCollection[3];
		XYSeries s0 = new XYSeries("",false); //autosort disabled
		data[0] =  new XYSeriesCollection(); 
		data[0].addSeries(s0);
		XYSeries s1 = new XYSeries("",false); //autosort disabled
		data[1] =  new XYSeriesCollection(); 
		data[1].addSeries(s1);
		XYSeries s2 = new XYSeries("",false); //autosort disabled
		data[2] =  new XYSeriesCollection();
		data[2].addSeries(s2);
		readData();
		chart[0] = createChart(0,data[0]);
		chart[1] = createChart(1,data[1]);
		chart[2] = createChart(2,data[2]);
		ChartPanel chartPanel0 = new ChartPanel(chart[0]);
		ChartPanel chartPanel1 = new ChartPanel(chart[1]);
		ChartPanel chartPanel2 = new ChartPanel(chart[2]);
		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		//JButton ok = new JButton("Aceptar");
		add(chartPanel0);
		add(chartPanel1);
		add(chartPanel2);
		//add(ok);
	}

	public void actionPerformed(ActionEvent e) {
		
		
	 }
	private void readData() {
		int j,i, nlines;
		File file = null;
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		for(j=0;j<3;j++){
			switch(j){
				case 0:{file = new File("profiles\\" + username + "_teorico.txt");break;}
				case 1:{file = new File("profiles\\" + username + "_reaccion.txt");break;}
				case 2:{file = new File("profiles\\" + username + "_pulso.txt");break;}
			}
			if(file.exists()){
			try {
				fis = new FileInputStream(file);
				bis = new BufferedInputStream(fis);
				dis = new DataInputStream(bis);

				// dis.available() returns 0 if the file does not have more lines.
				nlines = Integer.parseInt(dis.readLine());
				filedata = new double[nlines];
				for(i=0;i<nlines;i++){
					filedata[i] = Double.parseDouble(dis.readLine());
					data[j].getSeries(0).add((double)i, filedata[i]);
				}
				
				fis.close();
				bis.close();
				dis.close();
			} catch (FileNotFoundException e) {
			      e.printStackTrace();
			} catch (IOException e) {
			      e.printStackTrace();
		  }
		}
		}
	}

	private JFreeChart createChart(int index, XYDataset dataset) {
		JFreeChart chart = null;
		if( index == 0){
			chart = ChartFactory.createXYLineChart(
				"Examen Teorico",  // title
				"Numero del Intento",             // x-axis label
				"Correctas",   // y-axis label
				dataset,            // data
				PlotOrientation.VERTICAL,			// orientation
				false,               // create legend?
				true,               // generate tooltips?
				false);              // generate URLs?
		}
		if( index == 1){
			chart = ChartFactory.createXYLineChart(
					"Tiempo de Reaccion",  // title
					"Numero del Intento",             // x-axis label
					"Tiempo Promedio [ms]",   // y-axis label
					dataset,            // data
					PlotOrientation.VERTICAL,			// orientation
					false,               // create legend?
					true,               // generate tooltips?
					false);              // generate URLs?
			}
		if( index == 2){
			chart = ChartFactory.createXYLineChart(
					"X vs Y",  // title
					"Numero del Intento",             // x-axis label
					"Puntaje",   // y-axis label
					dataset,            // data
					PlotOrientation.VERTICAL,			// orientation
					false,               // create legend?
					true,               // generate tooltips?
					false);              // generate URLs?
			}
		
		chart.setBackgroundPaint(Color.white);
		
		XYPlot plot = (XYPlot) chart.getPlot();
		plot.setBackgroundPaint(Color.lightGray);
		plot.setDomainGridlinePaint(Color.white);
		plot.setRangeGridlinePaint(Color.white);
		plot.setAxisOffset(new RectangleInsets(5.0, 5.0, 5.0, 5.0));
		plot.getDomainAxis().setAutoRange(true);
		plot.getRangeAxis().setAutoRange(true);
		plot.setDomainCrosshairVisible(true);
		plot.setRangeCrosshairVisible(true);
		
		XYItemRenderer r = plot.getRenderer();
		if (r instanceof XYLineAndShapeRenderer) {
			XYLineAndShapeRenderer renderer = (XYLineAndShapeRenderer) r;
			renderer.setBaseShapesVisible(true);
			renderer.setBaseShapesFilled(true);
			renderer.setDrawSeriesLineAsPath(true);
		}

		return chart;
	}

	public void setUserName(String user){
		username = user;
	}
}
