import java.awt.event.*;
import javax.swing.JOptionPane;
import javax.swing.JMenuItem;
import javax.swing.JLabel;
import java.io.*;

/**
 * Clase que se encargara de todas las acciones tomadas por el usuario a travez del menubar.
 * @author Carlos Apablaza Brito & Rodrigo Mujica Ravest
 */
public class InsertElementListener implements ActionListener {
	teoricoFrame teoricoframe = null;
	chartsFrame chartsframe = null;
	pathFrame pathframe = null;
	reactionFrame reactionframe = null;
   JLabel label = new JLabel();
   User usuario = null;

   /**
    * Para obtener nombre de usuario, para leerlo desde otras clases y escribir
    * en el archivo correspondiente.
    */
   public String getUser(){
       return usuario.getName();
   }
   
   /**
    * Para setear el label mostrado en la ventana principal.
    * @param labelx label que se queire desplegar en el frame principal.
    */
   public void setLabel(JLabel labelx) {
       label=labelx;
   }

   /**
    * Que hacer al seleccionar alguna opcion del menu (crear o cargar perfil o realizar una prueba).
    * @param e Evento de clicklear sobre uno de los componentes del menu.
    */
   public void actionPerformed(ActionEvent e) {
      JMenuItem menuItem = (JMenuItem)(e.getSource());
      String text = menuItem.getText();
      String pathname;
      String pathname1;
      String pathname2;

      /**
       * Nuevo Perfil
       */
      if(text.equals("Nuevo Perfil...")) {
            String opc = JOptionPane.showInputDialog("Ingrese su nombre");
            usuario = new User(opc);
            label.setText("Usuario: " + opc);
            pathname = "profiles\\" + opc + "_teorico.txt";
            pathname1 = "profiles\\" + opc + "_reaccion.txt";
            pathname2 = "profiles\\" + opc + "_pulso.txt";
            // Leer archivo, si es que lo encuentra lo lee, sino crea uno.
            try {
                BufferedReader in = new BufferedReader(new FileReader(pathname));
                System.out.println("Se ha encontrado el archivo");
                JOptionPane.showMessageDialog(null, "Perfil ya existente.", "Error", JOptionPane.ERROR_MESSAGE);
                //String str;
                //while ((str = in.readLine()) != null) {
                //    System.out.println(str);
                //}
                in.close();
            }
            catch (IOException es) {
                System.out.println("Archivo no encontrado, Se creara uno");
                try{
                    // Create files
                    FileWriter fstream = new FileWriter(pathname);
                    BufferedWriter out = new BufferedWriter(fstream);
                    out.write("0");
                    out.flush();
                    FileWriter fstream1 = new FileWriter(pathname1);
                    BufferedWriter out1 = new BufferedWriter(fstream1);
                    out1.write("0");
                    out1.flush();
                    FileWriter fstream2 = new FileWriter(pathname2);
                    BufferedWriter out2 = new BufferedWriter(fstream2);
                    out2.write("0");
                    out2.flush();

                    //Close the output stream
                    out.close();
                    out1.close();
                    out2.close();
                    System.out.println("Se ha creado el archivo " + opc);

                }
                catch (Exception ex){//Catch exception if any
                      System.err.println("Error: " + ex.getMessage());
                }
            }
      }

      /**
       * Perfil Antiguo
       */
      if (text.equals("Cargar Perfil Antiguo")) {
            String opc = JOptionPane.showInputDialog("Ingrese su nombre");
            usuario = new User(opc);
            pathname = "profiles\\" + opc + "_teorico.txt";            
            //leer carpetas
            //if usuario no existente printf(usuario no existente)
            //else leer carpeta de usuario.
            // leer
            try {
                BufferedReader in = new BufferedReader(new FileReader(pathname));
                //String str;
                //while ((str = in.readLine()) != null) {
                //    System.out.println(str);
                //}
                in.close();
                label.setText("Usuario: " + opc);
            } catch (IOException es) {
                System.out.println("Archivo no encontrado");
                JOptionPane.showMessageDialog(null, "Perfil no existente", "Error", JOptionPane.ERROR_MESSAGE);
                label.setText("Debe identificarse con su nombre de usuario");
            }
      }
      
      /**
       * Funciones de Practica
       */
      else{
    	  if(usuario == null){
    		  JOptionPane.showMessageDialog(null, "Debe abrir o crear un perfil para poder realizar las pruebas", "Error", JOptionPane.ERROR_MESSAGE);
    	  }
    	  else{
    		  if (text.equals("Destreza Motora")){
    			  pathframe = new pathFrame(getUser());
    			  pathframe.setVisible(true);
    			  pathframe.setDefaultCloseOperation(2);
    		  }
    		  if (text.equals("Tiempo de Reaccion")){
    			  reactionframe = new reactionFrame(getUser());
    			  reactionframe.setVisible(true);
    			  reactionframe.setDefaultCloseOperation(2);
    		  }
    		  if (text.equals("Preguntas Teoricas")){
    			  Quiz test= new Quiz(10,"questions\\questions.txt"); 
    			  teoricoframe = new teoricoFrame(test, getUser());
    			  teoricoframe.setVisible(true);
    			  teoricoframe.setDefaultCloseOperation(2);
    		  }
    		  if (text.equals("Ver grafico evolutivo")){
    			  chartsframe = new chartsFrame(getUser());
    			  chartsframe.setVisible(true);
    			  chartsframe.setDefaultCloseOperation(2);
    			  
    		  }
    	  }
      }
      }
}