import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Random;

/**
 *
 * @author Carlos Apablaza B., Rodrigo Mujica R.
 *
 * Examen teorico simulado.
 */
public class Quiz {
	public Question questions[];
	public File file;
	public int nmax;
	public FileInputStream fis = null;
	public BufferedInputStream bis = null;
	public DataInputStream dis = null;

	public Quiz(int npreg, String pathName){
		int questionid,i;
		Random rand = new Random();
		nmax = npreg;
		file = new File(pathName);
		try {
			fis = new FileInputStream(file);

			// Here BufferedInputStream is added for fast reading.
			bis = new BufferedInputStream(fis);
			dis = new DataInputStream(bis);
			if(dis.markSupported())
				dis.mark(10000000);

			// dis.available() returns 0 if the file does not have more lines.
			questions = new Question[npreg];
			//questions[0] = new Question();
			for(i=0;i<npreg;i++){
				do{
						questionid = rand.nextInt(15);
			    }while(isAlreadyUsed(questionid+1));
				setLine(questionid*7);
				questions[i] = new Question(dis);
			}      
			//for(i=0;i<questions.length;i++){
			//	questions[i].printQuestion();
			//}  
			
			fis.close();
			bis.close();
			dis.close();

		  } catch (FileNotFoundException e) {
			      e.printStackTrace();
		  } catch (IOException e) {
			      e.printStackTrace();
		  }		
		}

	private void setLine(int line) throws IOException {
		int i;
		dis.reset();
		for(i=0;i<line;i++){
			dis.readLine();
		}
		
	}

	private boolean isAlreadyUsed(int questionid){
		int i;
		for(i=0;i<questions.length;i++){
			if(questions[i]!=null)
				if(Integer.parseInt(questions[i].number)==questionid)
					return true;
		}
		return false;
	}
}
