import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

/**
 * Panel presente en teoricoFrame, con la funcion mostrar al usuario las imagenes necesarias
 * (si es que existen) para contestar la pregunta actual.
 * @author Carlos Apablaza Brito & Rodrigo Mujica Ravest
 */
public class imgPanel extends JPanel{
	public Image pic = null;
	public ImageIcon img = new ImageIcon();
	
	 /**
	    * Definicion de como redibujar este panel cuando se hagan refrescos de la ventana.
	    */
	public void paintComponent (Graphics painter)
	   {
	    img.paintIcon(this, painter, 0, 0);
	}
	
	 /**
	    * Borra todos los elementos presentes en el panel para poder cargar los nuevos elementos
	    * de la pregunta a presentar.
	    */
	public void clean() {
		this.removeAll();
		this.setVisible(false);
		this.paintAll(getGraphics());
	}

	 /**
	    * Setea la imagen a desplegar por el pintado del panel.
	    * @param num numero identificador de la pregunta actual, con el cual se podra cargar la imagen
	    * que le corresponda
	    */
	public void setImage(String num){
		String pathname = "questions\\" + num + ".png";
		pic = Toolkit.getDefaultToolkit().getImage(pathname);
		img.setImage(pic);
		this.paintAll(getGraphics());
		this.setVisible(true);
	}
}

