import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.*;
import java.awt.BasicStroke;
import java.awt.Color;
import java.util.logging.Level;
import java.util.logging.Logger;
import  sun.audio.*;    //import the sun.audio package
import  java.io.*;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 * Barra de menu del frame principal, con todos los accesos a las funcionalidades del programa.
 * @author Carlos Apablaza Brito & Rodrigo Mujica Ravest
 */
public class pathFrame extends JFrame implements MouseListener, MouseMotionListener {
  private int[] xs = { 50, 100, 150, 200, 250, 300, 350, 400, 1000, 500};
  private int[] ys = { 400, 400, 400, 100, 400, 100, 100, 700, 100, 100};
  private int dragIndex = NOT_DRAGGING;
  private final static int NEIGHBORHOOD = 20;
  private final static int NOT_DRAGGING = -1;
  private int contOUT=0;
  private int contIN=0;
  boolean bool = false;
  private String username;

  int SCORE=0;


  GeneralPath path = new GeneralPath();
  GeneralPath path2 = new GeneralPath();
  GeneralPath path3 = new GeneralPath();

  pathFrame(String user) {
	  username = user;
    setTitle("PathTest");
    setSize(750, 470);
    setResizable(false);
    setVisible(true);
    addMouseListener(this);
    addMouseMotionListener(this);
  }

  public void paint(Graphics g) {
    for (int i = 0; i < 10; i++) {
      if(i==0) {
          g.setColor(Color.red);
          g.fillOval(xs[i] - 10, ys[i] - 10, 20, 20);
      }
      else if(i==9) {
          g.setColor(Color.green);
          g.fillOval(xs[i] - 10, ys[i] - 10, 20, 20);
      }
    }
    Graphics2D g2d = (Graphics2D) g;
    g2d.setColor(Color.black);
    
    path.moveTo(xs[0], ys[0]);
    path.curveTo(xs[1], ys[1], xs[2], ys[2], xs[3], ys[3]);

    path2.moveTo(xs[3], ys[3]);
    path2.curveTo(xs[4], ys[4], xs[5], ys[5], xs[6], ys[6]);

    path3.moveTo(xs[6], ys[6]);
    path3.curveTo(xs[7], ys[7], xs[8], ys[8], xs[9], ys[9]);

    BasicStroke stroke = new BasicStroke(
      10f,                       // grosor: 10 píxels
      BasicStroke.CAP_ROUND,      // terminación: recta
      BasicStroke.JOIN_ROUND,    // unión: redondeada
      10f                        // ángulo: 1 grado
    );

    g2d.setStroke(stroke);
    g2d.draw(path);
    g2d.draw(path2);
    g2d.draw(path3);
  }
  
  private void saveResults(int correct) {
		File infile;
		File outfile;
		
		infile = new File("profiles\\"+ username +"_pulso.txt");
		outfile = new File("profiles\\temp2.txt");
		addDataToFile(infile, outfile, correct);
		rearrangeFile(outfile,infile);
	}

	private void rearrangeFile(File in, File out) {
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		FileWriter fout = null;
		PrintWriter fileout = null;
		boolean isFirstLine = true;
		
		try {
			fout = new FileWriter(out);
			fileout = new PrintWriter(fout);
			fis = new FileInputStream(in);
			bis = new BufferedInputStream(fis);
			dis = new DataInputStream(bis);
			
			while(dis.available()>0){
				fileout.println(dis.readLine());
	            fileout.flush();
			}
			
			fis.close();
			bis.close();
			dis.close();
			fout.close();
			fileout.close();
		  } catch (FileNotFoundException e) {
			      e.printStackTrace();
		  } catch (IOException e) {
			      e.printStackTrace();
		  }		
		
	}

	private void addDataToFile(File in, File out, int correct) {
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		FileWriter fout = null;
		PrintWriter fileout = null;
		boolean isFirstLine = true;
		
		try {
			fout = new FileWriter(out);
			fileout = new PrintWriter(fout);
			fis = new FileInputStream(in);
			bis = new BufferedInputStream(fis);
			dis = new DataInputStream(bis);
			
			while(dis.available()>0){
				if(isFirstLine){
					int a = Integer.parseInt(dis.readLine());
					fileout.println(a+1);
					isFirstLine = false;
				}
				else
					fileout.println(dis.readLine());
	            fileout.flush();
			}
			fileout.println(correct);
			fileout.flush();
			
			fis.close();
			bis.close();
			dis.close();
			fout.close();
			fileout.close();
			

		  } catch (FileNotFoundException e) {
			      e.printStackTrace();
		  } catch (IOException e) {
			      e.printStackTrace();
		  }		
		
	}



  public void mousePressed(MouseEvent e) {
    dragIndex = NOT_DRAGGING;
    int minDistance = Integer.MAX_VALUE;
    int indexOfClosestPoint = -1;

    int deltaX = Math.abs(xs[0] - e.getX());
    int deltaY = Math.abs(ys[0] - e.getY());
    
    if(deltaX <= NEIGHBORHOOD/2 && deltaY <= NEIGHBORHOOD/2){
        System.out.println("Comenzo la prueba");
        bool = true;
        contIN=0;
        contOUT=0;
    }

    if (minDistance > NEIGHBORHOOD)
      return;

    dragIndex = indexOfClosestPoint;
  }

  public void mouseReleased(MouseEvent e) {
    if (dragIndex == NOT_DRAGGING)
      return;
    xs[dragIndex] = e.getX();
    ys[dragIndex] = e.getY();
    dragIndex = NOT_DRAGGING;
    repaint();
  }

  public void mouseDragged(MouseEvent e) {
    if (dragIndex == NOT_DRAGGING)
      return;

    xs[dragIndex] = e.getX();
    ys[dragIndex] = e.getY();
    repaint();
  }

  public void mouseClicked(MouseEvent e) {
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) {
  }


  
  public void mouseMoved(MouseEvent e) {
      if(bool){
          if(path.contains(e.getX(), e.getY())){
                contIN+=2;
          }
          else {
                contOUT++;
          }

          int deltaX = Math.abs(xs[9] - e.getX());
          int deltaY = Math.abs(ys[9] - e.getY());

            if((deltaX <= NEIGHBORHOOD/2) && (deltaY <= NEIGHBORHOOD/2)){
                System.out.println("Fin de la prueba");
                bool=false;
                SCORE=1000-contOUT+contIN;
                if(SCORE<0)SCORE=0;
                JOptionPane.showMessageDialog(null, "Termino la prueba con un puntaje de " + SCORE, "Resultado", JOptionPane.INFORMATION_MESSAGE);
                saveResults(SCORE);
                System.out.println("Score: "+ SCORE);
            }
      }
  }
}
